<script lang="ts" setup>
import { format } from "date-fns";
import { fr } from "date-fns/locale";
import { computed } from "vue";

interface Props {
  data: CsvData;
}

const props = defineProps<Props>();

const thematics = computed<string[]>(() => props.data.columns.slice(1));
const datesByYear = computed<{ [key: string]: any }>(() =>
  props.data.data.reduce(
    (acc: { [key: string]: string[] }, s: { dates: Date }) => {
      const year = `${s.dates.getFullYear()}`;
      if (!acc[year]) acc[year] = [];
      acc[year].push(s.dates.toLocaleDateString('fr-FR', { timezone: 'Europe/Paris', month: 'long', weekday: 'long', day: '2-digit' }));
      return acc;
    },
    {}
  )
);
const years = computed<string[]>(
  () =>
    [
      ...new Set(
        props.data.data.map((d: { dates: Date }) =>
          format(d.dates, "Y", { locale: fr })
        )
      ),
    ] as string[]
);
const dataEventsByYears = computed<{ [key: string]: string[] }>(() => {
  return props.data.data.reduce(
    (
      acc: { [key: string]: { [key: string]: string }[] },
      s: { dates: Date; [key: string]: string | Date }
    ) => {
      const year = `${s.dates.getFullYear()}`;
      if (!acc[year]) acc[year] = [];
      console.log(s)
      acc[year].push(
        Object.keys(s)
          .slice(1)
          .reduce((a: { [key: string]: string }, k: string) => {
            a[k] = s[k] as string;
            return a;
          }, {})
      );

      return acc;
    },
    {}
  );
});
</script>

<template>
  <!-- {{ props.data }} -->
  <div class="timeline-viewer">
    <table class="timeline-table">
      <thead>
        <th></th>
        <th v-for="year in years" :key="year">
          <h2>{{ year }}</h2>
        </th>
      </thead>
      <tbody>
        <tr v-for="(theme, index) in thematics" :key="theme">
          <td :data-theme="index">
            <h2 class="colored">{{ theme }}</h2>
          </td>
          <td v-for="year in years" :key="datesByYear[year]">
            <table :data-theme="index">
              <tbody>
                <tr>
                  <td
                    v-for="(dataEvent, dIndex) in dataEventsByYears[year]"
                    :key="dataEvent[theme]"
                  >
                    <div>
                      <span v-if="dataEvent[theme]">{{
                        datesByYear[year][dIndex]
                      }}</span>
                      <div v-if="dataEvent[theme]" class="marker"></div>
                      <div class="scrollable">{{ dataEvent[theme] }}</div>
                    </div>
                  </td>
                </tr>
              </tbody>
            </table>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<style lang="scss">
$td-padding: 0.75rem 0.5rem;
.timeline-viewer {
  .timeline-table {
    width: 100%;
    thead {
      text-align: left;
      th {
        padding: $td-padding;
      }
    }
    tbody {
      td {
        position: relative;
        padding: $td-padding;
        padding-top: 0;
        padding-bottom: 0;

        table {
          width: 100%;
          // border-right: 1px solid black;
          // border-left: 1px solid black;
          margin-top: 0;
          padding-top: 0;

          tbody {
            overflow-y: auto;
            td {
              width: 250px;
              max-width: 250px;
              min-width: 250px;
              height: 100px;
              position: relative;
              padding: $td-padding;
              padding-top: 0;
              padding-bottom: 0;
              word-break: break-all;

              // &:first-child {
              //   border-left: 1px solid lightseagreen;
              // }

              .scrollable {
                width: 100%;
                height: 100%;
                overflow: auto;
              }
            }
          }
        }
      }
    }
  }
  .marker {
    position: relative;
    width: 25%;
    height: 4px;
    border-radius: 4px;
  }
  [data-theme="0"] {
    .colored {
      color: red;
    }
    .marker {
      background-color: red;
    }
  }
  [data-theme="1"] {
    .colored {
      color: green;
    }
    .marker {
      background-color: green;
    }
  }
  [data-theme="2"] {
    .colored {
      color: lightgreen;
    }
    .marker {
      background-color: lightgreen;
    }
  }
  [data-theme="3"] {
    .colored {
      color: lightcoral;
    }
    .marker {
      background-color: lightcoral;
    }
  }
}
@media print {
  .csv-importer {
    display: none;
  }
  @page {
    size: A3 landscape;
    margin: 1.25cm;
  }
}
</style>
